#include <os.h>
#include "editactions.h"
#include "navigation.h"
//because of CHAR_WIDTH etc
#include "output.h"

inline int insert_range_action(char** textbufferp, int pos, int len, char* ins){
	if(strlen(*textbufferp) % 1024 + len > 1023)//allocate enough memory
		*textbufferp = realloc(*textbufferp, strlen(*textbufferp) + len + 1024 - (strlen(*textbufferp) + len) % 1024);
	if(*textbufferp == NULL)
		return 1;
	memmove((*textbufferp) + pos + len, (*textbufferp) + pos, strlen(*textbufferp) + 1 - pos);//move everything including null char!
    memcpy((*textbufferp) + pos, ins, len);
    return 0;
}

inline void remove_range_action(char* textbuffer, int pos, int len){
    if(textbuffer[pos+len] == '\0')
		textbuffer[pos] = '\0';
    else
        memmove(textbuffer + pos, textbuffer + pos + len, strlen(textbuffer) + 1 - (pos + len));//move everything after the range (including null character)
}



inline void delete_action(char* textbuffer, int* pos, int* cursorscreenrow, int* cursorscreencol, int* selectionstart, int* selectionend, int softnewline){
	if(*pos == *selectionend){
		if(softnewline)
			*cursorscreenrow -= countsoftnewl_withinitialw(textbuffer+*selectionstart, getw(textbuffer, *selectionstart), *selectionend - *selectionstart);
		else{
			char restore = textbuffer[*selectionend];
			textbuffer[*selectionend] = '\0';
			*cursorscreenrow -= countnewl(textbuffer+*selectionstart);
			textbuffer[*selectionend] = restore;
			*cursorscreencol -= getw_nosoftbreak(textbuffer, *selectionend) - getw_nosoftbreak(textbuffer, *selectionstart);
		}
	}
	remove_range_action(textbuffer, *selectionstart, *selectionend - *selectionstart);
	*pos = *selectionstart;
	*selectionend = *selectionstart;
}

inline int copy_action(char* textbuffer, int selectionstart, int selectionend, char** clipboardp){
	if(selectionstart != selectionend){
		free(*clipboardp);
		*clipboardp = (char*) malloc(selectionend - selectionstart + 1);
		if(*clipboardp == NULL)
			return 1;
		memcpy(*clipboardp, textbuffer + selectionstart, selectionend - selectionstart);
		(*clipboardp)[selectionend - selectionstart] = '\0';
	}
	return 0;
}

inline int cut_action(char* textbuffer, int* pos, int* cursorscreenrow, int* cursorscreencol, int* selectionstart, int* selectionend, int softnewline, char** clipboardp){
	if(*selectionstart != *selectionend){
		if(copy_action(textbuffer, *selectionstart, *selectionend, clipboardp) == 1)
			return 1;
		delete_action(textbuffer, pos, cursorscreenrow, cursorscreencol, selectionstart, selectionend, softnewline);
	}
	return 0;
}

inline int paste_action(char** textbufferp, int* pos, int* cursorscreenrow, int* cursorscreencol, int* selectionstart, int* selectionend, int softnewline, char* clipboard){
	if(clipboard != NULL){
		if(*selectionstart != *selectionend)
			delete_action(*textbufferp, pos, cursorscreenrow, cursorscreencol, selectionstart, selectionend, softnewline);
		if(insert_range_action(textbufferp, *pos, strlen(clipboard), clipboard) == 1)
			return 1;
		*pos += strlen(clipboard);
		*selectionstart = *pos;
		*selectionend = *pos;
		if(softnewline == TRUE)
			*cursorscreenrow += countsoftnewl(clipboard);
		else{
			*cursorscreenrow += countnewl(clipboard);
			*cursorscreencol += getw_nosoftbreak(*textbufferp, *pos) - *cursorscreencol;
		}
	}
	return 0;
}
